/*
* global.h
*
* global variables and definitions
*
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _ED2K_GUI_GLOBAL_H_INCLUDED_
#define _ED2K_GUI_GLOBAL_H_INCLUDED_

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#undef MIN	// these are defined in sys/param.h and in gtk/gtk.h ...
#undef MAX
#include <sys/param.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <gtk/gtk.h>

#define GNET_EXPERIMENTAL
#include <gnet.h>

#ifdef FREEBSD
#warning *****************************
#warning * FreeBSD people:
#warning *****************************
#endif
#include <libintl.h>	/* for internationalisation with gettext */
#include <locale.h>

#ifdef FREEBSD
# define OP_SYSTEM_STRING "FreeBSD"
#else
# ifdef LINUX
#  define OP_SYSTEM_STRING "Linux"
# else
#  ifdef NETBSD
#   define OP_SYSTEM_STRING "NetBSD"
#  else
#   ifdef OPENBSD
#    define OP_SYSTEM_STRING "OpenBSD"
#   else
#    define OP_SYSTEM_STRING ""				/* some other unix/platform */
#   endif /* ifdef OPENBSD */
#  endif /* ifdef NETBSD */
# endif /* ifdef LINUX */
#endif /* ifdef FREEBSD */


#define DUMMY_NICKNAME    "please wait"


#define NO_CORE_VERSION_YET                 ( core_build_date == 0 )

#define CORE_BUILD_1	0x02021c		// core from Feb 28, 2002

/* overnet cores earlier than 2002-Dec-07 won't return search results */
#define OVERNET_CORE_TOO_OLD		0x020c07

#define CORE_TOO_FAR_IN_THE_FUTURE	0x050000
#define CORE_JANUAR_2003		0x030101

#define CORE_SENDS_DL_ID_INSTEAD_OF_HASH_WITH_GAPS   ( core_build_date >  0x030809     )
#define CORE_HAS_NEW_UPLOAD_SLOT_MANAGEMENT          ( core_build_date >  0x030312     )
#define CORE_IS_UPLOAD_PRIORITY_ENABLED              ( core_build_date >= 0x030306     )
#define CORE_IS_GAP_ENABLED                          ( core_build_date >= CORE_BUILD_1 )

#define G_FREE(somepointer)	if(somepointer){g_free(somepointer);somepointer=NULL;}

#define PROCESS_GPTRARRAY(parr,castToDatatype,block)		{if(parr){gint gpainc; for(gpainc=0; parr->len > gpainc; gpainc++){ castToDatatype *item = (castToDatatype*) g_ptr_array_index(parr,gpainc); { block }}}}
#define PROCESS_GPTRARRAY_FROM_END(parr,castToDatatype,block)	{if(parr){gint gpainc; for(gpainc=parr->len-1; gpainc>=0; gpainc--){ castToDatatype *item = (castToDatatype*) g_ptr_array_index(parr,gpainc); { block }}}}


#define UPDATE_INTERVAL 1000    /* how often notebook pages are updated... (in ms)      */


#define	_(String)             gettext(String)  /* strings that we might want to translate */
#define gettext_noop(String)  String
#define N_(String)            gettext_noop(String)

#define FIXME_STRING	"[FIXME]"

void	main_clean_up_connections_and_callbacks_before_quit (void);

#endif
