/***************************************************************************
                          gui_flags.h  -  description
                             -------------------
    begin                : Thu Jun 27 2002
    copyright            : (C) 2002 by Tim-Philipp Mller
    email                : t.i.m@orange.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _ed2k_gui_gui_flags_h_included_
#define _ed2k_gui_gui_flags_h_included_

#include <glib.h>
#include <time.h>

#define IS_OVERNET	(core_is_overnet==TRUE)
#define IS_HYBRID	(core_is_hybrid ==TRUE)

/* the 'base' core version, e.g. 1049 => 49,  and 4912 => 49 */
#define CORE_VERSION_BASE  ((coreversion%100) > 40) ?  (coreversion%100) : (coreversion/100)

// So we know whether the core has crashed or
//   if it was the user shutting down the core

extern gboolean		connection_closed_deliberately;


// If this is set to TRUE we won't show the
//   connect-to dialog, assuming that we're quitting

extern gboolean		about_to_quit;



extern int		show_restart_success_message_on_next_packet;

extern int		local_donkey_pid;		// PID of local running donkey (TODO: should be pid_t?!)

extern int		coreversion;		   	// core client version

// flag, so we only show a warning message once if the core is older than it should be
extern int		first_time_we_get_options;

// These are set by the command line parse routine:
extern char	*shutdown_advcmd;	 // advanced command to send to core (instead of shutdown)
extern char	*shutdown_host;		 // host, port, user, password to use if only sending
extern char	*shutdown_user;		 //   shutdown message to core
extern char	*shutdown_pass;
extern int	 shutdown_port;
extern int 	 only_send_shutdown;
extern int	 only_send_advcmd;
extern int	 only_be_quiet;  	// be quiet when doing only_shutdown or only_send_advcmd

extern gboolean		core_is_overnet;	/* is this an overnet core? */
extern gboolean		core_is_hybrid;     /* is this an overnet/eDonkey hybrid core? */

#endif

