/***************************************************************************
                          guicoreconn.h  -  description
                             -------------------
    begin                : Wed Jun 26 2002
    copyright            : (C) 2002 by Tim-Philipp Mller
    email                : t.i.m@orange.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _ed2k_gui_guicoreconn_h_included_
#define _ed2k_gui_guicoreconn_h_included_

#include "global.h"
#include "ramfile.h"

#define GUICORECONN_CALLBACK_READ_SIZE	1024

// global, because send_logout() needs this
enum
{
 GUI_CORE_CONN_STATUS_NONE = 0,
 GUI_CORE_CONN_STATUS_CONNECTING,		// We are trying to connect
 GUI_CORE_CONN_STATUS_AUTHENTICATING,		// We are trying to log on (user/pass)
 GUI_CORE_CONN_STATUS_COMMUNICATING,		// We are logged on
 GUI_CORE_CONN_STATUS_CLOSED_DELIBERATELY,	// We've closed the connection deliberately
 GUI_CORE_CONN_STATUS_CLOSED_UNEXPECTEDLY,	// The connection broke unexpectedly
 GUI_CORE_CONN_STATUS_CLOSED_TIMEOUT,		// The connection timed out (no read for X seconds)
 GUI_CORE_CONN_STATUS_CLOSED_TIMEOUT_NO_DATA,	// The connection timed out and we've never received any data
} ;

#define CORE_IS_LOCAL	(guicore_conn_core_is_on_localhost==TRUE)
#define CORE_IS_ALIVE	((guicoreconn)&&(gnet_conn_is_connected(guicoreconn))&&guicoreconn_status==GUI_CORE_CONN_STATUS_COMMUNICATING)

extern GConn	*guicoreconn;				// the GUI-core connection

extern gboolean	 guicore_conn_core_is_on_localhost;
extern guint	 guicoreconn_status;			// status

// This variable is set accordingly in a specific case of connection loss/timeout
//	(we don't want to overwrite the options variable for that)
extern gboolean	 guicoreconn_do_reconnect;


gboolean	guicoreconn_set_connection (const gchar *hostname, guint port, const gchar *username, const gchar *password, GtkWidget *destroywidget);
gboolean	guicoreconn_connect (void);
void		guicoreconn_send_packet (ramfile *packet);
void		guicoreconn_close_connection (void);
void		guicoreconn_do_shutdown_connection (void);
void		guicoreconn_reconnect (void);

#endif

