/***************************************************************************
        shared_files.h  -  take care of all the shared files stuff (clist)
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2001-2002 by Tim-Philipp Mller
    email                : t.i.m at orange.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _ed2k_gui_shared_files_h_included_
#define _ed2k_gui_shared_files_h_included_

#include <gtk/gtk.h>

extern gboolean        core_supports_upload_priority;


struct SharedFilesDelayedAdd
{
	guint8 *hash;
	gchar  *name;
	gchar  *format;
	gchar  *type;
	guint   prio;
	guint32 size;
} ;

typedef struct SharedFilesDelayedAdd SharedFilesDelayedAdd;

guint           shared_files_get_count (void);

void            shared_files_clear_list (void);

void            shared_files_add_or_update_record ( const guint8 *hash,
                                                    const gchar *name,
                                                    guint32 size,
                                                    const gchar *format,
                                                    const gchar *type,
                                                    guint prio );



const guint8   *shared_files_get_hash_from_filename (const gchar *name);

guint32         shared_files_get_size_from_hash(const guint8 *hash);
gchar          *shared_files_get_filename_from_hash (const guint8 *hash);
gboolean        shared_files_check_hash_exists(const guint8 *hash);

void            shared_files_view_save_settings (void);

void            shared_files_update_rules_hint (void);

GtkWidget      *shared_files_create_view (void);

void            shared_files_remove_old (void);

void            shared_files_mark_all_for_removal (void);

void            shared_files_disable_sorting(void);

void            shared_files_enable_sorting(void);

gboolean        shared_files_no_delayed_adds_in_progess (void);



#endif
